# Huffstitution
*RU*:
Алло? У нас тут игровой автомат накрылся... Перезапускать пробовал... Целостность провода проверял... Хорошо, сейчас запущу снова... Так, на экране вижу какую-то надпись, тут видимо что-то вроде пароля нужно ввести... Не давали нам никакой бумажки с кодом... Ну и что теперь делать?... Сколько??? Нет, столько ждать мы не можем. Это самая популярная игра у детей. Эх... 

\*кладёт трубку\*

Ну, в общем, такие дела, сможешь сам посмотреть что там не так с этим автоматом?

*EN*:
Hello? Our slot machine is broken... Tried to restart... Checked the integrity of the wire... Okay, now I'll start it again... So, I see some kind of inscription on the screen, apparently something like input needs to be entered... They didn’t give us any papers with the code... So what should we do now?... How much to wait???? No, we can't wait that long. This is the most popular game for children. Eh...

\*hangs up\*

Well, can you see for yourself what’s wrong with this machine?

# Complexity
Medium

# Administration

Требуется выдать файл huffstitution.bin
# Writeup

Для реверса данной прошивки рекомендую выбрать radare2. IDA Pro тоже может хорошо дизассемблировать этот бинарный файл, но в ней нет поддержки данного микроконтроллера.

## Нахождение модели микроконтроллера

В случае с бинарным файлом, у него может сохраниться контекст программы (чего нет у .hex файлов). Поэтому мы можем узнать модель микроконтроллера с помощью функции `izz`:

![strings](https://i.imgur.com/8YlThjT.png)

P.S. По идее модель микроконтроллера всегда будет находится в секции `.deviceinfo`, поэтому можно использовать регулярное выражение по типу: `izz | grep .deviceinfo`.
Модель микроконтроллера дает нам доступ к его технической спецификации (datasheet), что очень важно при реверсе прошивки.

## Реверс прошивки

Открыв прошивку в radare2, мы можем посмотреть функцию main с помощью `pdf @main`

![main](https://i.imgur.com/N6hrNbd.png)

Здесь нас интересует функции `sym.huffstitution` и `strcmp` (так как, скорее всего, здесь идет проверка флага). Также важными для нас являются регистры `r24` и `r25`, значения которых обновляются после вызова функции `sym.UART_receive`. Скорее всего, в них сохраняется пользовательский ввод (запомним это). Далее аналогичным образом откроем функцию `sym.huffstitution`.

Итак, первая часть:

![lenCount](https://i.imgur.com/pHnhYy7.png)

Проанализировав данный код мы можем прийти к выводу, что `r24` и `r25` нужны для работы со строкой (из-за того, что в конце есть проверка на ноль байт), так как в начале `r24` (и иногда `r25`) увеличивается на 1, а после этого к значениям r24 и r25 прибавляются значения регистров `r18` и `r19`, которые в свою очередь берут свои значения из адреса `y+7` и `y+8`. Их значения берутся из `r24` и `r25`, из чего мы можем сделать вывод, что в данном фрагменте идет подсчёт длины введённой пользователем строки.

Перейдём к другому фрагменту:

![array](https://i.imgur.com/BL6Fcc5.png)

Здесь мы можем увидеть создание динамического массива длиной в `8 * {длина_введённой_строки}` (цепочка из четырех подряд идущих lsl и rol в данном случае представляет собой простое умножение на 8) с помощью стандартной функции `malloc`. После этого массив заполняется нулями с помощью функции `memset`.

Ну и сейчас перейдем к последнему фрагменту данного кода

![encode](https://i.imgur.com/ruoISQr.png)

Данный фрагмент кода задействует адрес `y+9` и `y+10`, которые в данный момент указывают на стек. Просмотрев стек, мы можем увидеть множество полей, заполненных строковыми нулями и единицами. 

![table](https://i.imgur.com/s80SVR6.png)

Взятие элемента из данного массива происходит путем преобразования символа введённой строки в индекс, который потом умножается на 8 и прибавляется к адресу начала массива. Далее берется указатель на созданный функцией динамический массив и к этим двум адресам применяется стандартная функция `strcat`. Далее идет увеличение индекса на 1 и сравнение его с длиной введённой строки. 
Из этого мы можем сделать вывод, что функция `sym.huffstitution` кодирует строку, заменяя каждый символ на элемент из таблицы замены.

Осталось только узнать, с чем идет сравнение в `strcmp`

![strcmp](https://i.imgur.com/XlISkI0.png)

После вызова функции `sym.huffstitution` адрес динамического массива сохранился в адрес `y+3` и `y+4`. Перед вызовом функции `strcmp` значения этих регистров сохраняются в регистры `r24` и `r25`, а потом в `r22` и `r23` сохраняется значение 0x100 - это адрес на закодированный флаг.

![flag](https://i.imgur.com/Ci6IKSZ.png)

Теперь, когда мы выяснили принцип работы программы, нужно декодировать флаг. Это можно сделать с помощью python скрипта, который лежит в ./chal/solve.py

# Flag
mctf{1s_7hIs_jU57_s1mpl3_5uBs71Tut10n}